Subject: Re: [RFC PATCH 1/2] net: Add sysfs files for threaded NAPI.

From: Jakub Kicinski <[email-masked]>
Date: Wed, 24 May 2023 08:55:07 -0700

On Wed, 24 May 2023 13:12:58 +0200 Sebastian Andrzej Siewior wrote:
> I've been looking into threaded NAPI. One awkward thing to do is
> to figure out the thread names, pids in order to adjust the thread
> priorities and SMP affinity.
> On PREEMPT_RT the NAPI thread is treated (by the user) the same way as
> the threaded interrupt which means a dedicate CPU affinity for the
> thread and a higher task priority to be favoured over other tasks on the
> CPU. Otherwise the NAPI thread can be preempted by other threads leading
> to delays in packet delivery.
> Having to run ps/ grep is awkward to get the PID right. It is not easy
> to match the interrupt since there is no obvious relation between the
> IRQ and the NAPI thread.
> NAPI threads are enabled often to mitigate the problems caused by a
> "pending" ksoftirqd (which has been mitigated recently by doing softiqrs
> regardless of ksoftirqd status). There is still the part that the NAPI
> thread does not use softnet_data::poll_list.

This needs to go to the netdev netlink family, not sysfs.
There's much more information about NAPI to expose and sysfs will
quickly start showing its limitations.